/*
 *  FILE    : PasswdDialog.java
 *  Ver     : 1.0      (Dec., `99)
 *  AUHTHOR : Sangyoon Oh
 *            soh@napc.syr.edu
 *
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import webwisdom.tango.config.*;

// password checking Dialog 
//
public class PasswdDialog extends JDialog {
    public PasswdDialog(MajordomoAdm _ma) {
        super((Frame) _ma.frame, true);
        ma = _ma;
        setTitle(ma.comMaster + " Password Checking");
        
        // login button
        okButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String validPass = ma.dm.getValue("community", ma.comMaster, "password");
                String newEncPasswd = PasswdManager.getEncPasswd(password.getText());
  
                // validation
                if(validPass != null && validPass.equals(newEncPasswd)) {
                    isAdmin = true;
                    adminPasswd = password.getText();
                    setVisible(false);
                }
                else {
                    JOptionPane.showMessageDialog( ma.frame, "Administrtor Password is not matched", "Invalid Password", JOptionPane.ERROR_MESSAGE );
                }
            }
        });
        
        // input panel
		gbConstraints.fill = GridBagConstraints.NONE;
		gbConstraints.anchor = GridBagConstraints.WEST;         
        JPanel inputPanel = new JPanel(gbLayout);
        inputPanel.setBorder(new CompoundBorder(
            new EmptyBorder(0, 5, 5, 5), new EtchedBorder()));        
    	addComponent(inputPanel, new JLabel("Password:"), 1, 0, 1, 1, new Insets(10, 5, 2, 2));
    	addComponent(inputPanel, password, 1, 1, 1, 1, new Insets(10, 0, 2, 5));
    	gbConstraints.anchor = GridBagConstraints.CENTER;  
    	addComponent(inputPanel, okButton, 2, 0, 2, 1, new Insets(20, 5, 5, 5));

        
        // header panel
        JPanel headerPanel = new JPanel();
        headerPanel.setBorder(new CompoundBorder(
            new EmptyBorder(5, 5, 2, 5), new EtchedBorder()));
        headerPanel.add(new JLabel("Check Admin Password"));
            
        // gui
        getContentPane().setLayout(new BorderLayout());
        getContentPane().add(headerPanel, BorderLayout.NORTH);
        getContentPane().add(inputPanel, BorderLayout.CENTER);            
        pack();
        validate();
    }
                
    // public method to get password                
    public String getPasswd() {
        return adminPasswd;
    }
    
    // public method to get validation 
    public boolean getValid() {
        return isAdmin;
    }
 
    // addComponent:
    // adds components to container according to grid
    // constraints parameters
    public void addComponent(JPanel p, JComponent c, int row, int column,
     	                     int width, int height, Insets insets) {
	     // set gridx and gridy
	     gbConstraints.gridx = column;
         gbConstraints.gridy = row;
         // set gridwidth and gridheight
	     gbConstraints.gridwidth = width;
         gbConstraints.gridheight = height;
         gbConstraints.insets = insets; 
	     // set constraints
	     gbLayout.setConstraints(c, gbConstraints);         
	     // add component
         p.add(c);
	}
	
	private GridBagConstraints gbConstraints = new GridBagConstraints();
	private GridBagLayout gbLayout = new GridBagLayout();   	
	protected JPasswordField password = new JPasswordField(12);
    protected JButton okButton = new JButton("OK");

    protected MajordomoAdm ma;
    protected String adminPasswd = "dafault";
    protected boolean isAdmin = false;
}
